#!/usr/bin/python

# $TSUKUBA_Release: Omni OpenMP/XcalableMP Compiler Software Version 0.5.1 $
# $TSUKUBA_Copyright:
#  Copyright (C) 2010 University of Tsukuba
#  
#  This software is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License version
#  2.1 published by the Free Software Foundation.
#  
#  Please check the Copyright and License information in the files named
#  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
#  Software release kit.
#  
#  * The specification of XcalableMP has been designed by the XcalableMP
#    Specification Working Group (http://www.xcalablemp.org/).
#  
#  * The development of this software is supported by "Seamless and
#    Highly-productive Parallel Programming Environment for
#    High-performance computing" project funded by Ministry of Education,
#    Culture, Sports, Science and Technology, Japan.
#  $

import sys, re

TYPE_ID_DICT = {}
TYPE_SERIAL_ID = 1

def replace_type_id(line):
    global TYPE_SERIAL_ID, TYPE_ID_DICT

    type_pat = re.compile(r'(type|ref)="([A-Z][0-9a-f]+)"')
    match = type_pat.search(line)
    while match:
        type_id = match.group(2)
        if not TYPE_ID_DICT.has_key(type_id):
            TYPE_ID_DICT[type_id] = str(TYPE_SERIAL_ID)
            TYPE_SERIAL_ID += 1
        line = type_pat.sub('%s="%s"' % (match.group(1), TYPE_ID_DICT[type_id],), line)
        match = type_pat.search(line)

    return line

def erase_time(line):
    return re.sub(r'time="[^"]+"', "", line)

def main():
    if len(sys.argv) == 1:
        data_input = sys.stdin
    elif len(sys.argv) == 2:
        data_input = file(sys.argv[1])
    else:
        print "%s [datafile]" % (sys.argv[0],)
        sys.exit()

    for line in data_input:
        line = replace_type_id(line)
        line = erase_time(line)
        print line,

if __name__ == '__main__':
    main()
